/*****************************************************
Chip type           : ATtiny26
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "global.h"
#include "defs.h"
#include "Boot.h"
#include "key.h"

int main(void)
{
vBoot ();


while (1)
      {
//*********************************** Datenausgabe *****************************************
	if (u8Bitbyte_2 & bZeitfenster)					//im Bustakt, alle 4,8ms ausfhren
		{
		if ((PINA & u8Maske) && (u8Counter < 0xFF)) ++u8Counter;//wenn maskierter Pin = High, Counter erhhen
		u8Bitbyte_2 &= ~bDataChecked;
	      }
     	else if (!(u8Bitbyte_2 & bDataChecked))			//wenn Counter noch nicht ausgewerted wurde
     		{
     		u8Bitbyte_2 |= bDataChecked;			//Daten als bearbeitet markieren
     		if (u8Counter < u8Counts)		//wenn Anzahl der Counts kleiner u8Counts (Gleis belegt)
     			{
     			if (!(u8Data & u8Maske))	//wenn neuer Zustand noch nicht ausgegeben
     				{
     				u8Zustand |= u8Maske;	//Bit im Zustandsregister setzen
     				u8Data |= u8Maske;	//und Bit im Ausgaberegister setzen
     				u8Bitbyte_2 |= bDataChange;
     				}
     			}
     		else if (u8Zustand & u8Maske)		//wenn Gleis frei und noch nicht bearbeitet
     			{
     			a8Delay [u8Gleis] = u8Prog_Verz;//Verzgerungszeit laden
     			u8Zustand &= ~u8Maske;		//als bearbeitet markieren
     			}
		if ((u8Data & u8Maske) && (!(u8Zustand & u8Maske)))//wenn Gleis frei aber Verzgerungszeit noch nicht abgelaufen
			{
			if (a8Delay [u8Gleis])
	     			{
	     			--a8Delay [u8Gleis];	//dann verringern
	     			}		
     			else 	{
     				u8Data &= ~u8Maske;	//sonst Gleis wieder frei geben
     				u8Bitbyte_2 |= bDataChange;
     				}
			}
     		if (u8Maske != 0x80)
     			{
     			u8Maske = u8Maske << 1;		//nchstes Bit maskieren
     			++u8Gleis;
     			}
     		else 	{
     			u8Maske = 1;
     			u8Gleis = 0;
     			}
     		u8Counter = 0;				//Counter zurcksetzen	
//      		u8Data = 0xFF;
//      		bDataChange = TRUE;
     		}
     	
//********************************** Programmierung ****************************************
	if ((u8Bitbyte_1 & bProgrammierung) && ((u8K106 & 0x40) || (u8Bitbyte_1 & bZentra_ON)))	//wenn wrend der Programmerung die Gleisspannung eingeschaltet wird
		{
		u8Bitbyte_1 |= bPressKey;				//Tastendruck simulieren um Programierung beenden
		}
	
	if (u8K106 & (0x20 + 0x40)) u8Bitbyte_2 |= bBus_Programmierung;
	else u8Bitbyte_2 &= ~bBus_Programmierung;
	
	if (PressKey ())					//wenn Taste gerckt
		{
		if (u8Bitbyte_1 & bProgrammierung) 			//und Programmierung aktiv
			{
			asm("cli");				//Interrupts abschalten, damit Interrupt Daten nicht ndert
			u8Prog_Adresse = au8Prog [0];		//Daten ins EEPROM schreiben
			u8Prog_Verz = au8Prog [1];
			u8Prog_Adress_Bufer = au8Prog [0];	//Daten im Zwischenpuffer sichern
			u8Bitbyte_1 &= ~bProgrammierung;		//Programmierung beenden
			u8K106 &= ~0x20;
			u8Bitbyte_2 |= bK106Change;
			au8Prog [0] = au8Prog_Save [0];		//Daten auf Bus wiederherstellen
			au8Prog [1] = au8Prog_Save [1];
			au8Prog [2] = au8Prog_Save [2];
			au8Prog [3] = au8Prog_Save [3];
			u8Change = 0x07;			//Knale als gendert markieren
			u8Bitbyte_1 |= bRestore;			//Bit zur wiederherstellung setzen
			asm("sei");				//Interrupt wieder freigeben
			PORTB &= ~LED;				//LED ausschalten
			}
		else if (!(u8Bitbyte_1 & bZentra_ON) && (!(u8K106 & (0x20 + 0x40))))//Zentrale aus und kein anderes Gert in Programmierung
			{
			asm("cli");				//Interrupts abschalten, damit Interrupt Daten nicht ndert
			u8K106 |= 0x20;
			u8Bitbyte_2 |= bK106Change;
			au8Prog_Save [0] = au8Prog [0];//Daten vom Bus speichern
			au8Prog_Save [1] = au8Prog [1];
			au8Prog_Save [2] = au8Prog [2];
			au8Prog_Save [3] = au8Prog [3];
			au8Prog [0] = u8Prog_Adresse;	//Daten aus EEPROM bernehmen
			au8Prog [1] = u8Prog_Verz;
			au8Prog [2] = u8Counts;
			au8Prog [3] = pgm_read_byte(& u8Prog_SoftVer);
			u8Change = 0x07;			//Knale als gendert markieren
			u8Bitbyte_1 |= bProgrammierung;		//Programmierung einleiten
			asm("sei");				//Interrupt wieder freigeben
			PORTB |= LED;			//LED einschalten
			}
		}
	};
}
