#ifndef GLOBAL_H_
#define GLOBAL_H_

#include "defs.h"
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>

//Variabeln im RAM
volatile UINT8	u8Timer0Ticks;			//erweiterter Zhler fr Timer 0
volatile UINT8 	u8Basis_Adresse;		//Basisadresse des aktuell bertagenen Frames
volatile UINT8 	u8Kanalnummer;			//Kanalnummer des aktuell bertagenen Kanales
volatile UINT8 	u8Adresse;			//Adresse der SX-Busdaten
volatile UINT8 	u8Data;				//Datenbyte fr SX-Busausgabe
volatile UINT8 	au8Prog [4];			//Variablen zur Programierung
volatile UINT8 	u8K106;				//Kanal 106 (wird zur Programierung bentigt)
volatile UINT8 	u8Change;			//gestzte bits fr genderte Kanaldaten (K0-2)
volatile UINT8	u8Prog_Adress_Bufer;		//Zwischenspeicher fr EEPROM-Variable
UINT8		u8Bitbyte_1;
UINT8		u8Bitbyte_2;
UINT8		u8Maske = 1;			//Maske zur Auswertung der Bits von Port A
UINT8		u8Counter;			//Zhler der HIGH's auf dem maskierten Portpin im Zeitfenster
UINT8		a8Delay [8];			//Verzgerungszeit fr jedes Bit des Bytes der 1. Adresse
UINT8		u8Gleis = 0;			//Bezeichenr fr berprftes Gleis
UINT8		u8Zustand;			//Zustand der einzelnen Gleise
UINT8 		au8Prog_Save [4];		//Zwischenspeicher fr aktuelle Buswerte



//Variabeln im EEPROM
UINT8	u8Prog_Adresse EEMEM = 20;	//1. Adresse die dem FD einprogrammiert wird (0 - 111)
UINT8	u8Prog_Verz EEMEM = 13;		//Freigabeverzgerung (vielfaches 76,8ms)
UINT8	u8Counts EEMEM = 80;		//Anzahl der Counts fr die Schwelle zwischen Belegt unf frei
const UINT8	u8Prog_SoftVer PROGMEM = 10;	//Softwareversion (1.0)

#endif /*GLOBAL_H_*/
