#include <avr/io.h>
#include <avr/interrupt.h>
#include "defs.h"
#include "key.h"

extern volatile UINT8	u8Timer0Ticks;			//erweiterter Zhler fr Timer 0
extern volatile UINT8 	u8Basis_Adresse;		//Basisadresse des aktuell bertagenen Frames
extern volatile UINT8 	u8Kanalnummer;			//Kanalnummer des aktuell bertagenen Kanales
extern volatile UINT8 	u8Adresse;			//Adresse der SX-Busdaten
extern volatile UINT8 	u8Data;				//Datenbyte fr SX-Busausgabe
extern volatile UINT8 	au8Prog [4];			//Variablen zur Programierung
extern volatile UINT8 	u8K106;				//Kanal 106 (wird zur Programierung bentigt)
extern volatile UINT8 	u8Change;			//gestzte bits fr genderte Kanaldaten (K0-2)
extern volatile UINT8 	u8Prog_Adress_Bufer;
extern UINT8	u8Bitbyte_1;
extern UINT8	u8Bitbyte_2;

// External Interrupt 0 service routine
ISR (INT0_vect)
{
UINT8 u8DataIn;
static UINT8 u8Datenbit = 0;
static UINT8 u8DataByte;
static UINT8 u8Out_Maske = 0x80;
static UINT8 u8DataOut;
static volatile UINT8 * pu8Bytezeiger;

if (PINB & T1) u8DataIn = 0xFF;				//Datenbit von T1 einlesen
else u8DataIn = 0;
//************************  SYNC-Kanal  ********************************
if (!(u8Bitbyte_1 & bSYNC_Detect))
	{
	switch (u8Datenbit)
		{
		case 0: if (!(u8DataIn)) ++u8Datenbit;	//SYNC 1 erkannt
		break;
		case 1: if (!(u8DataIn)) ++u8Datenbit;	//SYNC 2 erkannt
			else u8Datenbit = 0;
		break;
		case 2: if (!(u8DataIn)) ++u8Datenbit;	//SYNC 3 erkannt
			else u8Datenbit = 0;
		break;
		case 3: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else u8Datenbit = 0;
		break;
		case 4: if (u8DataIn) u8Bitbyte_1 |= bZentra_ON;	//Zentrale EIN / AUS
			else u8Bitbyte_1 &= ~bZentra_ON;
			++u8Datenbit;
		break;
		case 5: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else u8Datenbit = 0;
		break;
		case 6: if (u8DataIn) u8DataByte = 0;	//Basisadresse  Bit3
			else u8DataByte = 8;
			++u8Datenbit;
		break;
		case 7: if (!(u8DataIn)) u8DataByte |= 4;	//Basisadresse  Bit2
			++u8Datenbit;
		break;
		case 8: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else u8Datenbit = 0;
		break;
		case 9: if (!(u8DataIn)) u8DataByte |= 2;	//Basisadresse  Bit1
			++u8Datenbit;
		break;
		case 10: if (!(u8DataIn)) u8DataByte |= 1;//Basisadresse  Bit0
			++u8Datenbit;
		break;
		case 11: if (u8DataIn)				//Trennbit erkannt
				{
				u8Basis_Adresse = u8DataByte;//komplette Basisadresse bernehmen
				u8Bitbyte_1 |= bSYNC_Detect;
				u8Kanalnummer = 6;
				u8Adresse = (16 * u8Kanalnummer) + u8Basis_Adresse;//Adresse berechnen
				
				if (u8Adresse == 106)		//wenn nchster Kanal = 106
					{
					pu8Bytezeiger = & u8K106;//Variable an Pointer bergeben
					if (u8Bitbyte_2 & bK106Change) u8Bitbyte_1 |= bByteOut;//wenn Kanal gendert werden soll, Flag setzen
					else u8Bitbyte_1 &= ~bByteOut;
					}
				else if ((u8Bitbyte_1 & bProgrammierung) || (u8Bitbyte_1 & bRestore))
					{
					if (u8Adresse < 4)	//wenn aktuelle Adresse eine der Progammieradressen ist
						{
						pu8Bytezeiger = & au8Prog[u8Adresse];//Variable an Pointer bergeben
						if (u8Change & ((UINT8)1 << u8Adresse)) u8Bitbyte_1 |= bByteOut;//wenn Kanal gendert werden soll, Flag setzen
						}
					else u8Bitbyte_1 &= ~bByteOut;
					}
				else if (u8Prog_Adress_Bufer == u8Adresse)//wenn Ausgabe adresse aktiv
					{
					u8DataOut = u8Data;	//auszugebendes Byte an lokale Variable bergeben um Vernderung whrend der Ausgabe zu verhindern
					pu8Bytezeiger = & u8DataOut;//Variable an Pointer bergeben
					if ((u8Bitbyte_2 & bDataChange) && (!(u8Bitbyte_2 & bBus_Programmierung))) u8Bitbyte_1 |= bByteOut;//enn Kanal gendert werden soll und keine Programmierung auf dem Bus aktiv, Flag setzen
					else u8Bitbyte_1 &= ~bByteOut;
					}
				else u8Bitbyte_1 &= ~bByteOut;
					
				if (u8Bitbyte_2 & bZeitfenster) u8Bitbyte_2 &= ~bZeitfenster;//alle 4,8ms negiern
				else u8Bitbyte_2 |= bZeitfenster;			
				}
			u8Datenbit = 0;
		break;
		}
	}
//************************  Daten-Kanle  ********************************
else	{
	switch (u8Datenbit)
		{
		case 0: u8Out_Maske = 0x01;			//Bit7 maskieren
			if (u8DataIn)
				{
				u8DataByte = u8Out_Maske;	//Bit7 bernehmen
				}
			else u8DataByte = 0;
			++u8Datenbit;
		break;
		case 1: u8Out_Maske = 0x02;			//Bit6 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit6 bernehmen
			++u8Datenbit;
		break;
		case 2: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else	{
				u8Datenbit = 0;
				u8Bitbyte_1 &= ~bSYNC_Detect;
				}
			u8Bitbyte_1 |= bTrennbit;
		break;
		case 3: u8Out_Maske = 0x04;			//Bit5 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit5 bernehmen
			++u8Datenbit;
		break;
		case 4: u8Out_Maske = 0x08;			//Bit4 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit4 bernehmen
			++u8Datenbit;
		break;
		case 5: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else	{
				u8Datenbit = 0;
				u8Bitbyte_1 &= ~bSYNC_Detect;
				}
			u8Bitbyte_1 |= bTrennbit;
		break;
		case 6: u8Out_Maske = 0x10;			//Bit3 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit3 bernehmen
			++u8Datenbit;
		break;
		case 7: u8Out_Maske = 0x20;			//Bit2 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit2 bernehmen
			++u8Datenbit;
		break;
		case 8: if (u8DataIn) ++u8Datenbit;		//Trennbit erkannt
			else	{
				u8Datenbit = 0;
				u8Bitbyte_1 &= ~bSYNC_Detect;
				}
			u8Bitbyte_1 |= bTrennbit;
		break;
		case 9: u8Out_Maske = 0x40;			//Bit1 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit1 bernehmen
			++u8Datenbit;
		break;
		case 10: u8Out_Maske = 0x80;			//Bit0 maskieren
			if (u8DataIn) u8DataByte += u8Out_Maske;//Bit0 bernehmen
			++u8Datenbit;
		break;
		case 11: if (u8DataIn)				//Trennbit erkannt
				{
				if (106 == u8Adresse)
					{
					if (u8K106 == u8DataByte) u8Bitbyte_2 &= ~bK106Change;//wenn Daten ausgegeben wurden Changebit zurck nehmen
					if (!(u8Bitbyte_2 & bK106Change)) u8K106 = u8DataByte;//wenn Changebit nicht gesetzt , Daten vom Bus bernehmen
					}
				else if (u8Prog_Adress_Bufer == u8Adresse)
					{
					if (u8Data == u8DataByte) u8Bitbyte_2 &= ~bDataChange;//wenn Daten ausgegeben wurden Changebit zurck nehmen
					}
				else if (u8Adresse < 4)
					{
					if (au8Prog [u8Adresse] == u8DataByte)//wenn Daten vom Bus bernommen wurden
						{
						u8Change &= ~((UINT8)1 << u8Adresse);//nderungsmarkierung fr Kanal entfernen
						if (!(u8Change)) u8Bitbyte_1 &= ~bRestore;
						}			//wenn keine nderungsmarkierung neue Daten bernehmen
					if (!(u8Change & ((UINT8)1 << u8Adresse))) au8Prog [u8Adresse] = u8DataByte;
					}
				if (u8Kanalnummer != 0) --u8Kanalnummer;//wenn nicht alle Kanle bertragen wurden, nchsten Kanal
				else u8Bitbyte_1 &= ~bSYNC_Detect;	//sonst auf neuen SYNC-Kanal warten
				u8Adresse = (16 * u8Kanalnummer) + u8Basis_Adresse;//Adresse berechnen
				
				if (u8Adresse == 106)		//wenn nchster Kanal = 106
					{
					pu8Bytezeiger = & u8K106;//Variable an Pointer bergeben
				      if (u8Bitbyte_2 & bK106Change) u8Bitbyte_1 |= bByteOut;//wenn Kanal gendert werden soll, Flag setzen
				      }
				else if ((u8Bitbyte_1 & bProgrammierung) || (u8Bitbyte_1 & bRestore))
					{
					if (u8Adresse < 4)	//wenn aktuelle Adresse eine der Progammieradressen ist
						{
						pu8Bytezeiger = & au8Prog[u8Adresse];//Variable an Pointer bergeben
						if (u8Change & ((UINT8)1 << u8Adresse)) u8Bitbyte_1 |= bByteOut;//wenn Kanal gendert werden soll, Flag setzen
						}
					}
				else if (u8Prog_Adress_Bufer == u8Adresse)//wenn Ausgabe adresse aktiv
					{
					u8DataOut = u8Data;	//auszugebendes Byte an lokale Variable bergeben um Vernderung whrend der Ausgabe zu verhindern
					pu8Bytezeiger = & u8DataOut;//Variable an Pointer bergeben
					if ((u8Bitbyte_2 & bDataChange) && (!(u8Bitbyte_2 & bBus_Programmierung))) u8Bitbyte_1 |= bByteOut;//enn Kanal gendert werden soll und keine Programmierung auf dem Bus aktiv, Flag setzen
					}
				else u8Bitbyte_1 &= ~bByteOut;
				}
			u8Bitbyte_1 |= bTrennbit;
			u8Datenbit = 0;
		break;
		}
	
	if ((u8Bitbyte_1 & bByteOut) && (!(u8Bitbyte_1 & bTrennbit)))
		{
		if (* pu8Bytezeiger & u8Out_Maske) PORTB &= ~(D_HIGH + D_LOW);//High aktivieren, Low deaktivieren
		else PORTB |= (D_HIGH + D_LOW);	//sonst High deaktivieren, Low aktivieren
		}
	else	{
		PORTB &= ~D_LOW;				//Low deaktivieren
		PORTB |= D_HIGH;				//High deaktivieren
		}
	u8Bitbyte_1 &= ~bTrennbit;
	}
}

// Timer 0 overflow interrupt service routine (1ms)
ISR (TIMER0_OVF0_vect)
{
// Reinitialize Timer 0 value
TCNT0 -= 0x7D;
//#asm("sei")							//Interrupt wieder freigeben
++u8Timer0Ticks;

if (!(u8Timer0Ticks % 10)) 				//alle 10ms
	{
	vTestKey ();					//Tastenstatus abfragen
      }
}
