#include <avr/io.h>
#include "defs.h"

extern UINT8	u8Bitbyte_1;

/************************************************************
* Funktion 	:Abfrage des Tastaturportes und festsellen von	*
*		 gedrckt und losgelassen 				*
* bergabe 	:void								*
* Rckgabe 	:Staus in Variabeln bStatusKey, bPressKey, 	*
*		 bLongPressKey, bUnPressKey				*
************************************************************/
void vTestKey (void)
{
static unsigned char ucTASTE_1_Time;

if (!(PINB & TASTE))					//Taste gerckt
	{
	++ucTASTE_1_Time;					//Zhler erhhen
	if ( (!(u8Bitbyte_1 & bStatusKey)) &&  ucTASTE_1_Time > kPRELLZEIT)//wenn Taste noch nicht aktiv und Prellzeit berschritten
        	{
        	u8Bitbyte_1 |= bStatusKey;
        	u8Bitbyte_1 |= bPressKey;
        	}
//  	if ( (!(bLongStatusKey)) &&  ucTASTE_1_Time > kLONGPRELLZEIT)
//  		{
// 	      bLongPressKey = TRUE;			//Tastenstaus setzen
// 	      bLongStatusKey = TRUE;
// 	      }
   	}
else 	{							//Taste losgelassen
	if (u8Bitbyte_1 & bStatusKey)					//und noch nicht bemerkt
		{
		u8Bitbyte_1 &= ~bStatusKey;			//Tastenstatus lschen
// 		bLongStatusKey = FALSE;
		ucTASTE_1_Time = 0;			//nur nach erstem mal nach loslassen lschen
		}
	}
}

// /************************************************************
// * Funktion 	:lschen des Tastaturpuffers				*
// * bergabe 	:void								*
// * Rckgabe 	:void								*
// ************************************************************/
// void vClearKey (void)
// {
// bPressKey = FALSE;
// //bLongPressKey = FALSE;
// }

/************************************************************
* Funktion 	:Abfragen ob "ucTaste" gedrckt ist			*
* bergabe 	:void								*
* Rckgabe 	:true = gedrckt, false = nicht gedrckt		*
************************************************************/
unsigned char PressKey (void)
{
unsigned char ucStatus;
ucStatus = 0;
if (u8Bitbyte_1 & bPressKey)
	{
	ucStatus = 0xFF;					//gedrckt bergeben
	u8Bitbyte_1 &= ~bPressKey;				//und lschen
	}
return ucStatus;
}

// /************************************************************
// * Funktion 	:Abfragen ob "ucTaste" lange gedrckt ist		*
// * bergabe 	:void								*
// * Rckgabe 	:true = lange gedrckt, false = nicht l.gedrckt*
// ************************************************************/
// unsigned char LongpressKey (void)
// {
// unsigned char ucStatus;
// ucStatus = 0;
// if (bLongPressKey)
// 	{
// 	ucStatus = 0xFF;					//gedrckt bergeben
// 	bLongPressKey = FALSE;				//und lschen
// 	}
// return ucStatus;
// }
